﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Private xDate As String
	Private xTime As String
	Private xDescription As String
	Private xPrice As String
	Private xobPrice As String
	Private xosPrice As String
	Private xogPrice As String
	Private xmbPrice As String
	Private xmsPrice As String
	Private xmgPrice As String
	Private xmaPrice As String

	Private FileName As String

	Public Receive As String
	Public Transmit As String

	Public host As OkHttpClient
	Public Request As OkHttpRequest
	Public hostAddress As String

	Public mDate As Long
	Public mTime As Long

	Private ion As Object
End Sub

Sub Globals
	Private List1 As ListView
	Private dPanel As Panel
	Private ShowPix As ImageView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Title = Application.LabelName & " Events "

'	Activity.AddMenuItem("Edit","Edit")
'	Activity.AddMenuItem("Delete","Delete")

	List1.Initialize("List1")
	List1.Color = Colors.Black
	List1.TwoLinesLayout.Label.TextColor = Colors.Green
	List1.SingleLineLayout.Label.TextColor = Colors.Green
	Activity.AddView(List1,0,0,100%x,100%y)

	dPanel.Initialize("")
	dPanel.Color = Colors.Black
	Activity.AddView(dPanel,0,0,0,0)

	ShowPix.Initialize("")
	ShowPix.Gravity = Gravity.FILL
	dPanel.AddView(ShowPix,0,0,100%x,100%y)

	host.Initialize("host")

	hostAddress = Main.hostAddress

	mDate = DateTime.Now
	mTime = DateTime.Now

	xDate = "24-Nov-2018"
	xTime = "12:00"
	xDescription = "New Event Name"
	xPrice = "$20"
	xobPrice = "$20"
	xosPrice = "$20"
	xogPrice = "$20"
	xmbPrice = "$20"
	xmsPrice = "$20"
	xmgPrice = "$20"
	xmaPrice = "$20"

	MakeList
End Sub

Sub Activity_Resume

End Sub


Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If dPanel.Width > 10 Then
		dPanel.SetLayoutAnimated(100,0,0,0,0)
		Return True	
	End If

	Return False
End Sub



Sub Edit_Click

End Sub

Sub Delete_Click
	
End Sub


Sub MakeList
	List1.Clear

	List1.AddTwoLines(xDate,"Date of Event")
	List1.AddTwoLines(xTime,"Time of Event")
	List1.AddTwoLines(xDescription,"Description of Event")
	List1.AddTwoLines(xPrice,"General Admission")
	List1.AddTwoLines(xobPrice,"Own group Bronze Price")
	List1.AddTwoLines(xosPrice,"Own group Silver Price")
	List1.AddTwoLines(xogPrice,"Own group Gold Price")
	List1.AddTwoLines(xmbPrice,"The Movement Bronze Price")
	List1.AddTwoLines(xmsPrice,"The Movement Silver Price")
	List1.AddTwoLines(xmgPrice,"The Movement Gold Price")
	List1.AddTwoLines(xmaPrice,"The Movement Administrator Price")
	List1.AddSingleLine("TAKE PICTURE OF FLYER")
	List1.AddSingleLine("VIEW FLYER")
	List1.AddSingleLine("SAVE EVENT")
End Sub



Sub List1_ItemClick (Position As Int, Value As Object)
	Private dd As DateDialog
	Private td As TimeDialog
	Private id As InputDialog

	Private xLine As String


	If Position = 0 Then
		dd.DateTicks = mDate

		If dd.Show("","Enter Event Date","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		mDate = dd.DateTicks

		DateTime.DateFormat = "dd-MMM-yyyy"

		xDate = DateTime.Date(mDate)

	Else If Position = 1 Then
		td.TimeTicks = mTime

		If td.Show("", "Enter Event Time", "Save", "Cancel", "",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		mTime = td.TimeTicks

		DateTime.TimeFormat = "HH:mm"

	Else If Position = 2 Then
		id.Input = xDescription
		id.PasswordMode = False
		id.InputType = id.INPUT_TYPE_TEXT

		If id.Show("Enter Event Name","Name","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		xLine = id.Input

		If xLine.Trim.Length < 3 Then Return

		xDescription = xLine

	Else If Position = 3 Then
		id.Input = udf.Val(xPrice)
		id.PasswordMode = False
		id.InputType = id.INPUT_TYPE_DECIMAL_NUMBERS

		If id.Show("Enter General Admission","Price","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		xLine = id.Input

		If udf.Val(xLine) < 0 Then Return

		xPrice = "$ " & udf.sNumber(udf.Val(xLine),10).Trim

	Else If Position = 4 Then
		id.Input = udf.Val(xobPrice)
		id.PasswordMode = False
		id.InputType = id.INPUT_TYPE_DECIMAL_NUMBERS

		If id.Show("Own Group Bronze","Bronze","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		xLine = id.Input

		If udf.Val(xLine) < 0 Then Return

		xobPrice = "$ " & udf.sNumber(udf.Val(xLine),10).Trim

	Else If Position = 5 Then
		id.Input = udf.Val(xosPrice)
		id.PasswordMode = False
		id.InputType = id.INPUT_TYPE_DECIMAL_NUMBERS

		If id.Show("Own Group Silver","Silver","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		xLine = id.Input

		If udf.Val(xLine) < 0 Then Return

		xosPrice = "$ " & udf.sNumber(udf.Val(xLine),10).Trim

	Else If Position = 6 Then
		id.Input = udf.Val(xogPrice)
		id.PasswordMode = False
		id.InputType = id.INPUT_TYPE_DECIMAL_NUMBERS

		If id.Show("Own Group Gold","Gold","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		xLine = id.Input

		If udf.Val(xLine) < 0 Then Return

		xogPrice = "$ " & udf.sNumber(udf.Val(xLine),10).Trim

	Else If Position = 7 Then
		id.Input = udf.Val(xmbPrice)
		id.PasswordMode = False
		id.InputType = id.INPUT_TYPE_DECIMAL_NUMBERS

		If id.Show("The Movement Bronze","Bronze","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		xLine = id.Input

		If udf.Val(xLine) < 0 Then Return

		xmbPrice = "$ " & udf.sNumber(udf.Val(xLine),10).Trim

	Else If Position = 8 Then
		id.Input = udf.Val(xmsPrice)
		id.PasswordMode = False
		id.InputType = id.INPUT_TYPE_DECIMAL_NUMBERS

		If id.Show("The Movement Silver","Silver","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		xLine = id.Input

		If udf.Val(xLine) < 0 Then Return

		xmsPrice = "$ " & udf.sNumber(udf.Val(xLine),10).Trim

	Else If Position = 9 Then
		id.Input = udf.Val(xmgPrice)
		id.PasswordMode = False
		id.InputType = id.INPUT_TYPE_DECIMAL_NUMBERS

		If id.Show("The Movement Gold","Gold","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		xLine = id.Input

		If udf.Val(xLine) < 0 Then Return

		xmgPrice = "$ " & udf.sNumber(udf.Val(xLine),10).Trim

	Else If Position = 10 Then
		id.Input = udf.Val(xmaPrice)
		id.PasswordMode = False
		id.InputType = id.INPUT_TYPE_DECIMAL_NUMBERS

		If id.Show("The Movement Administrators","Administrators","Save","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

		xLine = id.Input

		If udf.Val(xLine) < 0 Then Return

		xmaPrice = "$ " & udf.sNumber(udf.Val(xLine),10).Trim

	Else If Position = 11 Then
		TakePicture

	Else If Position = 12 Then
		If File.Exists(File.DirRootExternal,"neweventflyer.jpg") = False Then
			ToastMessageShow("No Flyer Exists",False)
			Return
		End If

		ShowPix.Bitmap = LoadBitmap(File.DirRootExternal,"neweventflyer.jpg")
		dPanel.SetLayoutAnimated(250,0,0,100%x,100%y)

		Return

	Else If Position = 13 Then
		DateTime.DateFormat = "yyyyMMdd"
		DateTime.TimeFormat = "HHmmss"

		FileName = DateTime.Date(DateTime.Now)
		FileName = FileName & "-" & DateTime.Time(DateTime.Now)
		FileName = FileName & "-" & Main.SysPhone

		Transmit = hostAddress & "?akShun=SaveEvent"
		Transmit = Transmit & "&iMEi=" & udf.httpstring(Main.SysIMEI)
		Transmit = Transmit & "&SiM=" & udf.httpstring(Main.SysSIM)
		Transmit = Transmit & "&Phone=" & udf.httpstring(Main.SysPhone)
		Transmit = Transmit & "&Date=" & udf.httpstring(udf.FixDate(xDate))
		Transmit = Transmit & "&Time=" & udf.httpstring(xTime.SubString2(0,2) & xTime.SubString2(3,5))
		Transmit = Transmit & "&Description=" & udf.httpstring(xDescription)
		Transmit = Transmit & "&Price=" & udf.httpstring(udf.Val(xPrice))
		Transmit = Transmit & "&obPrice=" & udf.httpstring(udf.Val(xobPrice))
		Transmit = Transmit & "&osPrice=" & udf.httpstring(udf.Val(xosPrice))
		Transmit = Transmit & "&ogPrice=" & udf.httpstring(udf.Val(xogPrice))
		Transmit = Transmit & "&mbPrice=" & udf.httpstring(udf.Val(xmbPrice))
		Transmit = Transmit & "&msPrice=" & udf.httpstring(udf.Val(xmsPrice))
		Transmit = Transmit & "&mgPrice=" & udf.httpstring(udf.Val(xmgPrice))
		Transmit = Transmit & "&maPrice=" & udf.httpstring(udf.Val(xmaPrice))
		Transmit = Transmit & "&Flyer=" & udf.httpstring(FileName)

		Request.InitializeGet(Transmit)
		Request.Timeout = 30000
		host.Execute(Request, 1)

		ProgressDialogShow("Processing.....")

		Return

	End If

	MakeList
End Sub



Sub UploadPIX
	Private j As HttpJob
	Private bm As Bitmap
	Private xLine As String
	Private Parameterz As Map
	Private Out As OutputStream
	Private mp As MultipartFileData


	bm.Initialize(File.DirRootExternal,"neweventflyer.jpg")

	Out = File.OpenOutput(File.DirRootExternal, "flyer.jpg",False)
	bm.WriteToStream(Out,40,"JPEG")
	Out.Close

	Parameterz.Initialize
	Parameterz.Put("FileName",FileName)

	j.Initialize("", Me)

	mp.Initialize
	mp.KeyName = "file"
	mp.FileName = "flyer.jpg"
	mp.ContentType = "image/jpeg"
	mp.Dir = File.DirRootExternal

	j.PostMultipart(Starter.ServerIP & "uploadpix.php",Parameterz, Array(mp))

	Wait For (j) JobDone(j As HttpJob)

	If j.Success Then
		xLine = j.GetString

		Log("Response = " & xLine)
	End If

	j.Release

	If File.Exists(File.DirDefaultExternal,"neweventflyer.jpg") Then
		File.Delete(File.DirDefaultExternal,"neweventflyer.jpg")
	End If

	If File.Exists(File.DirDefaultExternal,"flyer.jpg") Then
		File.Delete(File.DirDefaultExternal,"flyer.jpg")
	End If

	Activity.Finish
End Sub





Sub TakePicture
	Private i As Intent
	Private uri As Uri

	i.Initialize("android.media.action.IMAGE_CAPTURE", "")

	uri.Parse("file://" & File.Combine(File.DirRootExternal, "neweventflyer.jpg"))

	i.PutExtra("output", uri) 'the image will be saved to this path

	Try
		StartActivityForResult(i)
	Catch
		ToastMessageShow("Camera is not available.", True)
	End Try
End Sub


Sub ion_Event (MethodName As String, Args() As Object) As Object
	If Args(0) = -1 Then
		ToastMessageShow("Image of Flyer stored",False)
	End If

	Return Null
End Sub


Sub StartActivityForResult(i As Intent)
	Private jo As JavaObject = GetBA

	ion = jo.CreateEvent("anywheresoftware.b4a.IOnActivityResult", "ion", Null)

	jo.RunMethod("startActivityForResult", Array As Object(ion, i))
End Sub


Sub GetBA As Object
	Private jo As JavaObject
	Private cls As String = Me

	cls = cls.SubString("class ".Length)
	jo.InitializeStatic(cls)

	Return jo.GetField("processBA")
End Sub





Sub host_ResponseError (Response As OkHttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	ProgressDialogHide

	Msgbox("Error","Host Error")
End Sub

Sub host_ResponseSuccess (Response As OkHttpResponse, TaskId As Int)
	Response.GetAsynchronously("Rx",File.OpenOutput(File.DirInternalCache,"received.data.event",False),True,TaskId)
End Sub

Sub Rx_StreamFinish (Success As Boolean, TaskId As Int)
	ProgressDialogHide

	Receive = File.ReadString(File.DirInternalCache,"received.data.event")

	If Receive.StartsWith("SE") Then
		ToastMessageShow("Event saved ..... uploading Flyer",True)
		UploadPIX

	Else
		Msgbox (Receive,"Server Response:")

	End If
End Sub
