﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Public Status As String

	Public Receive As String
	Public Transmit As String

	Public host As OkHttpClient
	Public Request As OkHttpRequest
	Public hostAddress As String

	Public xLevels As List

	Public xDetails As Map
End Sub

Sub Globals
	Private List1 As ListView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Title = Application.LabelName & " Approvals "

	List1.Initialize("List1")
	List1.Color = Colors.Black
	List1.TwoLinesLayout.Label.TextColor = Colors.Green
	List1.SingleLineLayout.Label.TextColor = Colors.Green
	Activity.AddView(List1,0,0,100%x,100%y)

	Activity.AddMenuItem("Show Pending Members","Members")
	If Main.SysLevel.StartsWith("X") Then Activity.AddMenuItem("Show Pending Events","Events")
	If Main.SysLevel.StartsWith("X") Then Activity.AddMenuItem("Show Pending News","News")

	host.Initialize("host")

	hostAddress = Starter.ServerIP & "moveit.php"

	xLevels.Initialize

	If Main.SysLevel.StartsWith("X") Then xLevels.Add("X - System")

	xLevels.Add("A - Administrator")
	xLevels.Add("G - Gold")
	xLevels.Add("S - Silver")
	xLevels.Add("B - Bronze")

	xDetails.Initialize
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub





Sub Members_Click
	Status = "M"

	Transmit = hostAddress & "?akShun=ListMembers"
	Transmit = Transmit & "&iMEi=" & udf.httpstring(Main.SysIMEI)
	Transmit = Transmit & "&SiM=" & udf.httpstring(Main.SysSIM)
	Transmit = Transmit & "&Phone=" & udf.httpstring(Main.SysPhone)
	Transmit = Transmit & "&Level=N"

	Request.InitializeGet(Transmit)
	Request.Timeout = 30000
	host.Execute(Request, 1)

	ProgressDialogShow("Processing.....")
End Sub


Sub Events_Click
	Status = "E"

	Transmit = hostAddress & "?akShun=PendingEvents"
	Transmit = Transmit & "&iMEi=" & udf.httpstring(Main.SysIMEI)
	Transmit = Transmit & "&SiM=" & udf.httpstring(Main.SysSIM)
	Transmit = Transmit & "&Phone=" & udf.httpstring(Main.SysPhone)

	Request.InitializeGet(Transmit)
	Request.Timeout = 30000
	host.Execute(Request, 1)

	ProgressDialogShow("Processing.....")
End Sub


Sub News_Click
	Status = "N"

	Transmit = hostAddress & "?akShun=PendingNews"
	Transmit = Transmit & "&iMEi=" & udf.httpstring(Main.SysIMEI)
	Transmit = Transmit & "&SiM=" & udf.httpstring(Main.SysSIM)
	Transmit = Transmit & "&Phone=" & udf.httpstring(Main.SysPhone)

	Request.InitializeGet(Transmit)
	Request.Timeout = 30000
	host.Execute(Request, 1)

	ProgressDialogShow("Processing.....")
End Sub




Sub GetMembers
	Private xLine As String

	Private xPhone As String
	Private xName As String
	Private xGroup As String
	Private xGroupName As String
	Private xRowID As String

	ProgressDialogShow("Processing ..... ")

	List1.Clear

	Do While Receive.Trim.Length > 1
		If Receive.StartsWith("<members>") Then
			Receive = Receive.SubString(9)

		Else If Receive.StartsWith("</phone>") Then
			Receive = Receive.SubString(8)

		Else If Receive.StartsWith("</name>") Then
			Receive = Receive.SubString(7)

		Else If Receive.StartsWith("</membership>") Then
			Receive = Receive.SubString(13)

		Else If Receive.StartsWith("</group>") Then
			Receive = Receive.SubString(8)

		Else If Receive.StartsWith("</rowid>") Then
			Receive = Receive.SubString(8)

		Else If Receive.StartsWith("<level>") Then
			Receive = Receive.SubString(16)

		Else If Receive.StartsWith("<phone>") Then
			xLine = Receive.SubString(7)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xPhone = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<name>") Then
			xLine = Receive.SubString(6)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xName = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<membership>") Then
			xLine = Receive.SubString(12)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xGroup = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<group>") Then
			xLine = Receive.SubString(7)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xGroupName = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<rowid>") Then
			xLine = Receive.SubString(7)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xRowID = xLine.SubString2(0,xLine.IndexOf("<"))

			List1.AddTwoLines2(xPhone & " - " & xName,xGroupName,xRowID)

			xLine = "(" & xPhone & ") " & xName & " - " & xGroupName

			xDetails.Put(xRowID,xLine)

		Else
			Receive = ""

		End If
	Loop

	ProgressDialogHide
End Sub


Sub GetEvents
	Private xLine As String

	Private xTime As String
	Private xDate As String
	Private xRowID As String
	Private xFlyer As String
	Private xDescription As String


	List1.Clear

	Do While Receive.Trim.Length > 1
		If Receive.StartsWith("<pendingevents>") Then
			Receive = Receive.SubString(15)

		Else If Receive.StartsWith("</date>") Then
			Receive = Receive.SubString(7)

		Else If Receive.StartsWith("</time>") Then
			Receive = Receive.SubString(7)

		Else If Receive.StartsWith("</flyer>") Then
			Receive = Receive.SubString(8)

		Else If Receive.StartsWith("</description>") Then
			Receive = Receive.SubString(14)

		Else If Receive.StartsWith("</rowid>") Then
			Receive = Receive.SubString(8)

		Else If Receive.StartsWith("<date>") Then
			xLine = Receive.SubString(6)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xDate = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<time>") Then
			xLine = Receive.SubString(6)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xTime = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<description>") Then
			xLine = Receive.SubString(13)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xDescription = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<flyer>") Then
			xLine = Receive.SubString(7)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xFlyer = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<rowid>") Then
			xLine = Receive.SubString(7)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xRowID = xLine.SubString2(0,xLine.IndexOf("<"))

			List1.AddTwoLines2(xDescription,xDate & " @ " & xTime,xRowID)

		Else
			Receive = ""

		End If
	Loop
End Sub












Sub List1_ItemClick (Position As Int, Value As Object)
	If Status.StartsWith("M") Then
		ProcessMembers(Position,Value)

	Else If Status.StartsWith("E") Then
		ProcessEvents(Position,Value)

	Else If Status.StartsWith("N") Then
		ProcessNews(Position,Value)

	End If
End Sub


Sub ProcessMembers(Position As Int, Value As Object)
	Private xc As Int


	xc = InputList(xLevels,"Select Level",-1)

	If xc < 0 Then Return

	If Msgbox2("Process Member Enrollment","Confirm Approval","Approve","Cancel","",LoadBitmap(File.DirAssets,"icon.png")) <> DialogResponse.POSITIVE Then Return

	List1.RemoveAt(Position)

	Transmit = hostAddress & "?akShun=Approve"
	Transmit = Transmit & "&iMEi=" & udf.httpstring(Main.SysIMEI)
	Transmit = Transmit & "&SiM=" & udf.httpstring(Main.SysSIM)
	Transmit = Transmit & "&Phone=" & udf.httpstring(Main.SysPhone)
	Transmit = Transmit & "&RowID=" & udf.httpstring(Value)
	Transmit = Transmit & "&Level=" & udf.httpstring(xLevels.Get(xc))

	Request.InitializeGet(Transmit)
	Request.Timeout = 30000
	host.Execute(Request, 1)

	ProgressDialogShow("Processing.....")
End Sub


Sub ProcessEvents(Position As Int, Value As Object)
	Starter.RowID = Value

	StartActivity(showevent)
End Sub


Sub ProcessNews(Position As Int, Value As Object)
	
End Sub




Sub host_ResponseError (Response As OkHttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	ProgressDialogHide

	Msgbox("Error","Host Error")
End Sub

Sub host_ResponseSuccess (Response As OkHttpResponse, TaskId As Int)
	Response.GetAsynchronously("Rx",File.OpenOutput(File.DirInternalCache,"received.data.approvals",False),True,TaskId)
End Sub

Sub Rx_StreamFinish (Success As Boolean, TaskId As Int)
	Private xLine As String


	ProgressDialogHide

	Receive = File.ReadString(File.DirInternalCache,"received.data.approvals")

	If Receive.StartsWith("<members>") Then
		GetMembers

	Else If Receive.StartsWith("AP") Then
		ToastMessageShow("Membership Application Updated",False)

	Else If Receive.StartsWith("<pendingevents>") Then
		GetEvents

	Else
		Msgbox (Receive,"Server Response:")

	End If
End Sub

