﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Public Receive As String
	Public Transmit As String

	Public host As OkHttpClient
	Public Request As OkHttpRequest
	Public hostAddress As String
End Sub

Sub Globals
	Dim List1 As ListView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Title = Application.LabelName & " Events "

	Activity.AddMenuItem("Add New Event","New_Event")

	List1.Initialize("List1")
	List1.Color = Colors.Black
	List1.TwoLinesLayout.Label.TextColor = Colors.Green
	List1.SingleLineLayout.Label.TextColor = Colors.Green
	Activity.AddView(List1,0,0,100%x,100%y)

	host.Initialize("host")

	hostAddress = Main.hostAddress


End Sub

Sub Activity_Resume
	Transmit = hostAddress & "?akShun=ListEvents"
	Transmit = Transmit & "&iMEi=" & udf.httpstring(Main.SysIMEI)
	Transmit = Transmit & "&SiM=" & udf.httpstring(Main.SysSIM)
	Transmit = Transmit & "&Phone=" & udf.httpstring(Main.SysPhone)

	Request.InitializeGet(Transmit)
	Request.Timeout = 30000
	host.Execute(Request, 1)

	ProgressDialogShow("Processing.....")

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub





Sub New_Event_Click
	If "AX".Contains(Main.SysLevel) Then
		Main.SysRowID = -1
		StartActivity(newevent)
	End If
End Sub


Sub List1_ItemClick (Position As Int, Value As Object)
	Starter.RowID = Value

	StartActivity(showevent)
End Sub








Sub GetEvents
	Private xLine As String

	Private xTime As String
	Private xDate As String
	Private xRowID As String
	Private xFlyer As String
	Private xDescription As String


	List1.Clear

	Do While Receive.Trim.Length > 1
		If Receive.StartsWith("<events>") Then
			Receive = Receive.SubString(8)

		Else If Receive.StartsWith("</date>") Then
			Receive = Receive.SubString(7)

		Else If Receive.StartsWith("</time>") Then
			Receive = Receive.SubString(7)

		Else If Receive.StartsWith("</flyer>") Then
			Receive = Receive.SubString(8)

		Else If Receive.StartsWith("</description>") Then
			Receive = Receive.SubString(14)

		Else If Receive.StartsWith("</rowid>") Then
			Receive = Receive.SubString(8)

		Else If Receive.StartsWith("<date>") Then
			xLine = Receive.SubString(6)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xDate = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<time>") Then
			xLine = Receive.SubString(6)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xTime = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<description>") Then
			xLine = Receive.SubString(13)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xDescription = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<flyer>") Then
			xLine = Receive.SubString(7)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xFlyer = xLine.SubString2(0,xLine.IndexOf("<"))

		Else If Receive.StartsWith("<rowid>") Then
			xLine = Receive.SubString(7)
			Receive = xLine.SubString(xLine.IndexOf("<"))
			xRowID = xLine.SubString2(0,xLine.IndexOf("<"))

			List1.AddTwoLines2(xDescription,xDate & " @ " & xTime,xRowID)

		Else
			Receive = ""

		End If
	Loop


End Sub








Sub host_ResponseError (Response As OkHttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	ProgressDialogHide

	Msgbox("Error","Host Error")
End Sub

Sub host_ResponseSuccess (Response As OkHttpResponse, TaskId As Int)
	Response.GetAsynchronously("Rx",File.OpenOutput(File.DirInternalCache,"received.data.events",False),True,TaskId)
End Sub

Sub Rx_StreamFinish (Success As Boolean, TaskId As Int)
	Private xLine As String


	ProgressDialogHide

	Receive = File.ReadString(File.DirInternalCache,"received.data.events")

	If Receive.StartsWith("<events>") Then
		GetEvents

	Else If Receive.StartsWith("AP") Then
		ToastMessageShow("Membership Application Updated",False)

	Else If Receive.StartsWith("<transaction>") Then
		ToastMessageShow("Reservation Successful",False)

	Else
		Msgbox (Receive,"Server Response:")

	End If
End Sub


