﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Private logo As ImageView
	Private QRImage As ImageView

	Private messageQR As String

	Private err As String
	Private mask_pattern As Int
	
	Private rsie As RSImageEffects
	Private rsip As RSImageProcessing
	Private b As Bitmap

	Private shape As String
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Title = Application.LabelName & " Membership "

	Private iconSpace As Double
	Private logoWidth As Double
	Private logoHeight As Double


	Activity.Title = Application.LabelName & " v-" & Application.VersionName

	iconSpace = 2%x
	logoWidth = 100%x - (2 * iconSpace)
	logoHeight = logoWidth * 0.60


	Activity.Color = Colors.White

	logo.Initialize("")
	logo.Gravity = Gravity.FILL
	logo.Bitmap = LoadBitmap(File.DirAssets,"logo.png")
	Activity.AddView(logo,iconSpace,iconSpace,logoWidth,logoHeight)

	QRImage.Initialize("")
	QRImage.Gravity = Gravity.FILL
	Activity.AddView(QRImage,20%x,logo.Top + logo.Height + iconSpace,60%x,60%x)

	rsip.Initialize
End Sub

Sub Activity_Resume
	messageQR = Main.SysPhone

	DrawQRCode
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub





Sub DrawQRCode
	shape = "s"
	mask_pattern = 3
	err = "H"

	QRcode.Draw_QR_Code(messageQR,err,mask_pattern,Colors.White,Colors.Black,shape)    'Pass the message, the error level, the masking pattern, the background color, and the foreground/pixel color

	b = LoadBitmap(File.DirRootExternal, "/pictures/QRcode.png")                       'Load the created png file into ImageView1
	b = rsip.createScaledBitmap(b, 445, 445, False)                                    'createScaledBitmap seems to produce a better compressed image
	QRImage.Bitmap = rsie.RoundCorner(b, 15)                                        'round bitmap corners
End Sub
