﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

	Private ion As Object

End Sub

Sub Globals
	Dim List1 As ListView
	Dim dPanel As Panel
	Dim webPage As WebView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Title = Application.LabelName & " Settings "

	List1.Initialize("List1")
	List1.Color = Colors.Black
	List1.TwoLinesLayout.Label.TextColor = Colors.Green
	List1.SingleLineLayout.Label.TextColor = Colors.Green
	Activity.AddView(List1,0,0,100%x,100%y)

	dPanel.Initialize("")
	Activity.AddView(dPanel,0,0,0,0)

	webPage.Initialize("")
	dPanel.AddView(webPage,0,0,100%x,100%y)

	List1.AddTwoLines2(Main.SysPhone,"My Phone Number","1")
	List1.AddTwoLines2(Main.SysName,"My Name","2")
	List1.AddTwoLines2(Main.SysGroup,"My Group","3")
	If "AX".Contains(Main.SysLevel) Then List1.AddSingleLine2("UPLOAD Flyer","4")
	List1.AddSingleLine2("SHOW Flyer","5")
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If dPanel.Width > 10 Then
		dPanel.SetLayoutAnimated(100,0,0,0,0)
		Return True
	End If

	Return False
End Sub



Sub List1_ItemClick (Position As Int, Value As Object)
	Private xLine As String


	xLine = Value

	If xLine = 1 Then

	Else If xLine = 2 Then

	Else If xLine = 3 Then

	Else If xLine = 4 Then
		TakePicture

	Else If xLine = 5 Then
		webPage.LoadUrl(Starter.ServerIP & "showflyer.php?Group=" & Main.SysGroup)
		dPanel.SetLayoutAnimated(250,0,0,100%x,100%y)

	End If
End Sub
	


Sub UploadPIX
	Private j As HttpJob
	Private bm As Bitmap
	Private xLine As String
	Private Parameterz As Map
	Private Out As OutputStream
	Private mp As MultipartFileData


	bm.Initialize(File.DirRootExternal,"groupflyer.jpg")

	Out = File.OpenOutput(File.DirRootExternal, "flyer.jpg",False)
	bm.WriteToStream(Out,40,"JPEG")
	Out.Close

	Parameterz.Initialize
	Parameterz.Put("FileName",Main.SysGroup & "-flyer")

	j.Initialize("", Me)

	mp.Initialize
	mp.KeyName = "file"
	mp.FileName = "flyer.jpg"
	mp.ContentType = "image/jpeg"
	mp.Dir = File.DirRootExternal

	j.PostMultipart(Starter.ServerIP & "uploadpix.php",Parameterz, Array(mp))

	Wait For (j) JobDone(j As HttpJob)

	If j.Success Then
		xLine = j.GetString

		Log("Response = " & xLine)
	End If

	j.Release

	If File.Exists(File.DirDefaultExternal,"groupflyer.jpg") Then
		File.Delete(File.DirDefaultExternal,"groupflyer.jpg")
	End If

	If File.Exists(File.DirDefaultExternal,"flyer.jpg") Then
		File.Delete(File.DirDefaultExternal,"flyer.jpg")
	End If

	ToastMessageShow("Flyer Uploaded!",False)
End Sub




Sub TakePicture
	Private i As Intent
	Private uri As Uri

	i.Initialize("android.media.action.IMAGE_CAPTURE", "")

	uri.Parse("file://" & File.Combine(File.DirRootExternal, "groupflyer.jpg"))

	i.PutExtra("output", uri) 'the image will be saved to this path

	Try
		StartActivityForResult(i)
	Catch
		ToastMessageShow("Camera is not available.", True)
	End Try
End Sub


Sub ion_Event (MethodName As String, Args() As Object) As Object
	If Args(0) = -1 Then
		ToastMessageShow("Image of Flyer stored",False)
		UploadPIX
	End If

	Return Null
End Sub


Sub StartActivityForResult(i As Intent)
	Private jo As JavaObject = GetBA

	ion = jo.CreateEvent("anywheresoftware.b4a.IOnActivityResult", "ion", Null)

	jo.RunMethod("startActivityForResult", Array As Object(ion, i))
End Sub


Sub GetBA As Object
	Private jo As JavaObject
	Private cls As String = Me

	cls = cls.SubString("class ".Length)
	jo.InitializeStatic(cls)

	Return jo.GetField("processBA")
End Sub






