﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.3
@EndOfDesignText@
Sub Process_Globals

End Sub


Sub FixDate(xDate As String) As String
	If xDate.SubString2(3,6).StartsWith("Jan") Then Return xDate.SubString(7) & "01" & xDate.SubString2(0,2)
	If xDate.SubString2(3,6).StartsWith("Feb") Then Return xDate.SubString(7) & "02" & xDate.SubString2(0,2)	
	If xDate.SubString2(3,6).StartsWith("Mar") Then Return xDate.SubString(7) & "03" & xDate.SubString2(0,2)	
	If xDate.SubString2(3,6).StartsWith("Apr") Then Return xDate.SubString(7) & "04" & xDate.SubString2(0,2)
	If xDate.SubString2(3,6).StartsWith("May") Then Return xDate.SubString(7) & "05" & xDate.SubString2(0,2)
	If xDate.SubString2(3,6).StartsWith("Jun") Then Return xDate.SubString(7) & "06" & xDate.SubString2(0,2)	
	If xDate.SubString2(3,6).StartsWith("Jul") Then Return xDate.SubString(7) & "07" & xDate.SubString2(0,2)	
	If xDate.SubString2(3,6).StartsWith("Aug") Then Return xDate.SubString(7) & "08" & xDate.SubString2(0,2)
	If xDate.SubString2(3,6).StartsWith("Sep") Then Return xDate.SubString(7) & "09" & xDate.SubString2(0,2)
	If xDate.SubString2(3,6).StartsWith("Oct") Then Return xDate.SubString(7) & "10" & xDate.SubString2(0,2)
	If xDate.SubString2(3,6).StartsWith("Nov") Then Return xDate.SubString(7) & "11" & xDate.SubString2(0,2)
	If xDate.SubString2(3,6).StartsWith("Dec") Then Return xDate.SubString(7) & "12" & xDate.SubString2(0,2)
	Return "00000000"
End Sub


Sub EncodeTID(xString As String) As String
	Dim xc As Int
	Dim xLine As String

	xLine = ""
	xString = xString & "00000000"

	For xc = 1 To 4
		xLine = xLine & xString.SubString2(0,2)
		xLine = xLine & CheckDigit(xLine)
		xString = xString.SubString(2)
	Next

	Return xLine
End Sub

Sub CheckDigit(xString As String) As String
	Dim xResult As Int

	xResult = 0

	Do While xString.Length > 0
		xResult = xResult + Val(xString.SubString2(0,1))

		If xResult > 9 Then
			xResult = xResult - 9
		End If

		xString = xString.SubString(1)
	Loop

	Return (9 - xResult)
End Sub

Sub Msg(xString As String)
	DateTime.TimeFormat = "HH:mm:ss"
	Log(DateTime.Time(DateTime.Now) & " " & xString)
End Sub

Sub httpString(xString As String) As String
	xString = xString.Replace(" ","%20")
	xString = xString.Replace("&","%26")
	xString = xString.Replace("'","%27")
	xString = xString.Replace(",","%2C")
	xString = xString.Replace("?","%3F")

	Return xString
End Sub

Sub FriendlyTime(xData As String) As String
	Dim mLine As String

	mLine = xData.SubString(xData.Length - 4)

	If mLine.SubString2(0,2) = "00" Then
		mLine = "12" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "12" Then
		mLine = "12" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "13" Then
		mLine = "1" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "14" Then
		mLine = "2" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "15" Then
		mLine = "3" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "16" Then
		mLine = "4" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "17" Then
		mLine = "5" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "18" Then
		mLine = "6" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "19" Then
		mLine = "7" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "20" Then
		mLine = "8" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "21" Then
		mLine = "9" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "22" Then
		mLine = "10" & ":" & mLine.SubString2(2,4)
	Else If mLine.SubString2(0,2) = "23" Then
		mLine = "11" & ":" & mLine.SubString2(2,4)
	Else
		mLine = mLine.SubString2(0,2) & ":" & mLine.SubString2(2,4)
	End If

	Return (xData.SubString2(0,xData.Length - 4) & " (" & mLine & ")")
End Sub

Sub NumOnly(xString As String) As String
	Dim xLine As String
	Dim xNumbers As String
	Dim xz As Int

	xLine=""
	xNumbers = "0123456789."

	For xz = 0 To xString.Length - 1
		If xNumbers.IndexOf(xString.CharAt(xz)) >= 0 Then
			xLine = xLine & xString.CharAt(xz)
		End If
	Next

	Return xLine
End Sub

Sub Val(xString As String) As Float
	If xString.Length <1 Then
		Return 0
	Else
		Return NumOnly(xString)
	End If
End Sub

Sub sNumber(xAmount As Double,xLen As Int) As String
	Dim xLine As String
	Dim xTemp As String

	xTemp = "                    "

	xLine = NumberFormat2(xAmount,1,2,2,True)

	Return (xTemp.SubString2(0,xLen - xLine.Length) & xLine)
End Sub

Sub zNumber(xAmount As Double,xLen As Int) As String
	Dim xLine As String
	Dim xTemp As String

	xTemp = "                    "

	xLine = NumberFormat2(xAmount,1,0,0,True)

	If xLine.Length >= xLen Then
		Return xLine.SubString2(0,xLen)
	Else
		Return (xTemp.SubString2(0,xLen - xLine.Length) & xLine)
	End If
End Sub

Sub sString(xString As String,xLen As Int) As String
	Do While xString.Length < xLen
		xString = xString & " "
	Loop	

	Return xString.SubString2(0,xLen)
End Sub

Sub Trim(xString As String) As String
	Return(xString.Trim)
End Sub

Sub TransType(xString As String) As String
	If xString = "2" Then
		Return "2 Ball  "
	Else If xString = "3" Then
		Return "3 Ball  "
	Else If xString = "4" Then
		Return "4 Ball  "
	Else If xString = "B" Then
		Return "Borlette"
	Else If xString = "M" Then
		Return "Marriage"
	Else
		Return "Error   "
	End If
End Sub

Sub Right(xString As String,xLen As Int) As String
	If xLen >= xString.Length Then
		Return(xString)
	Else
		Return(xString.SubString(xString.Length - xLen))
	End If	
End Sub

Sub Left(xString As String,xLen As Int) As String
	If xLen >= xString.Length Then
		Return(xString)
	Else
		Return(xString.SubString2(0,xLen))
	End If
End Sub

Sub Len(xString As String) As String
	Return(xString.Length)
End Sub

Sub RightTrim(xString As String) As String
	Do While xString.EndsWith(" ")
		xString = xString.SubString2(0,xString.Length -1)
	Loop

	Return xString
End Sub

Sub MakeDate(xString As String) As String
	Dim xLine As String

	xLine = xString.SubString2(4,6) & "-"
	xLine = xLine & xString.SubString2(6,8) & "-"
	xLine = xLine & xString.SubString2(0,4) & " "
	xLine = xLine & xString.SubString2(8,10) & ":"
	xLine = xLine & xString.SubString2(10,12) & ":"
	xLine = xLine & xString.SubString2(12,14)

	Return xLine
End Sub

Sub RoundMeUp(xAmount As Double) As Double
	Dim xString As String
	Dim xNumber As Int

	xString = sNumber(xAmount,10)
	xNumber = xString.SubString(8)

	If xNumber = 0 Then
		Return xAmount

	Else If xNumber <= 25 Then
		xNumber = xAmount
		xAmount = xNumber + 0.25
		Return xAmount

	Else If xNumber <= 50 Then
		xNumber = xAmount
		xAmount = xNumber + 0.50
		Return xAmount

	Else If xNumber <= 75 Then
		xNumber = xAmount
		xAmount = xNumber + 0.75
		Return xAmount

	Else
		xNumber = xAmount
		xAmount = xNumber + 1
		Return xAmount

	End If
End Sub


Sub ShowNumbersPlayed(xNumbers As String) As String
	Dim xLine As String
	Dim xc As Int


	xLine = ""

	Do While xNumbers.Length > 0
		xc = xNumbers.SubString2(0,2)

		If xc > 10 Then
			xLine = xLine & NumberFormat(xc,2,0) & " "

		Else If xc > 0 Then
			xLine = xLine & NumberFormat(xc,1,0) & "  "

		Else
			xLine = xLine & "   "

		End If

		xNumbers = xNumbers.SubString(2)
	Loop

	Return xLine
End Sub

Sub SToD(xDate As String) As Long
	DateTime.DateFormat = "yyyyMMdd"

	Return DateTime.DateParse(xDate.SubString2(0,8))
End Sub

Sub CalcDateDiff(xStart As String,xEnd As String) As Long
	Dim xOne As Long
	Dim xTwo As Long

	If xStart >= xEnd Then Return 0

	DateTime.DateFormat = "yyyyMMdd"
	DateTime.TimeFormat = "HHmm"

	xOne = DateTime.DateTimeParse(xStart.SubString2(0,8),xStart.SubString2(8,12))
	xTwo = DateTime.DateTimeParse(xEnd.SubString2(0,8),xEnd.SubString2(8,12))

	Return (xTwo - xOne)
End Sub

Sub DateToString(xDateS As String,xDateE As String) As String
	Dim xList As String

	If xDateS.Length <> 12 Then Return ""
	If xDateE.Length <> 12 Then Return ""

	If xDateE <= xDateS Then Return ""

	xList = ""

	If xDateE.StartsWith(xDateS.SubString2(0,8)) Then
		xList = xDateS & xDateE
	Else
		xList = xDateS & xDateS.SubString2(0,8) & "2400"
		xList = xList & xDateE.SubString2(0,8) & "0000" & xDateE
	End If

	Return xList
End Sub


Sub HowManyHours(xTimeS As String,xTimeE As String) As Double
	Dim xStart As Int
	Dim xEnd As Int

	If xTimeS.Length <> 4 Then Return 0
	If xTimeE.Length <> 4 Then Return 0

	If xTimeE <= xTimeS Then Return 0

	xStart = (xTimeS.SubString2(0,2) * 60) + Val(xTimeS.SubString2(2,4))
	xEnd = (xTimeE.SubString2(0,2) * 60) + Val(xTimeE.SubString2(2,4))

	Return (xEnd - xStart) / 60
End Sub

Sub NIBCalc(xAmount As Int,xType As String) As Double
	Dim xInsurable As Double
	Dim xEmployee As Double
	Dim xEmployer As Double
	Dim xTotalNIB As Double

	If xAmount > 650 Then
		xInsurable = 650
	Else
		xInsurable = xAmount
	End If

	xTotalNIB = xInsurable * 0.098

	If xInsurable < 60 Then 
		xEmployee = xInsurable * 0.017
	Else
		xEmployee = xInsurable * 0.039
	End If

	xEmployer = xTotalNIB - xEmployee

	If xType.StartsWith("E") Then Return xEmployee
	If xType.StartsWith("R") Then Return xEmployer
	If xType.StartsWith("I") Then Return xInsurable
End Sub

Sub GetCategory(xCat As String) As String
	If xCat.StartsWith("BN") Then
		Return "Banner"

	Else If xCat.StartsWith("GC") Then
		Return "Group Costume"

	Else If xCat.StartsWith("GM") Then
		Return "Group Music"

	Else If xCat.StartsWith("GP") Then
		 Return "Group Performance"

	Else If xCat.StartsWith("GL") Then
		Return "Lead Piece"

	Else If xCat.StartsWith("ID") Then
		 Return "Individual Costumes"

	Else If xCat.StartsWith("FD") Then
		Return "Free Dancers"

	Else If xCat.StartsWith("SD") Then
		Return "Step Down Dancers"

	Else If xCat.StartsWith("OT") Then
		Return "Off The Shoulder Dancers"

	Else If xCat.StartsWith("CD") Then
		Return "Choreographed Dancers"

	End If
End Sub

Sub GetSubCategory(xCat As String,xSub As Int) As String
	If xCat.StartsWith("BN") Then
		Return "Banner"

	Else If xCat.StartsWith("GC") Then
		If xSub = 1 Then
			Return "Execution of Theme"
		Else If xSub = 2 Then
			Return "Costume Construction"
		End If

	Else If xCat.StartsWith("GM") Then
		If xSub = 1 Then
			Return "Musicanship"
		Else If xSub = 2 Then
			Return "Content / Performance"
		End If

	Else If xCat.StartsWith("GP") Then
		Return "Performance Skills"

	Else If xCat.StartsWith("GL") Then
		If xSub = 1 Then
			Return "Theme Depiction"
		Else If xSub = 2 Then
			Return "Costume/Construction/Presentation"
		End If

	Else If xCat.StartsWith("ID") Then
		If xSub = 1 Then
			Return "Visual Impact"
		Else If xSub = 2 Then
			Return "Execution of Theme"
		Else If xSub = 3 Then
			Return "Colour Coordination/Originality"
		Else If xSub = 4 Then
			Return "Craftsmanship"
		Else If xSub = 5 Then
			Return "Mobility & Construction"
		End If

	Else If xCat.StartsWith("FD") Then
		If xSub = 1 Then
			Return "Theme Depiction"
		Else If xSub = 2 Then
			Return "Costume/Construction/Presentation"
		End If

	Else If xCat.StartsWith("SD") Then
		If xSub = 1 Then
			Return "Theme Depiction"
		Else If xSub = 2 Then
			Return "Costume/Construction/Presentation"
		End If

	Else If xCat.StartsWith("OT") Then
		If xSub = 1 Then
			Return "Costume Construction Presentation"
		Else If xSub = 2 Then
			Return "Performance Skills"
		End If

	Else If xCat.StartsWith("CD") Then
		If xSub = 1 Then
			Return "Spacing/Formations/Transitions"
		Else If xSub = 2 Then
			Return "Costume"
		End If
	End If
End Sub

Sub GetGroup(xCode As String) As String
	If xCode.StartsWith("101") Then Return "Valley Boys"
	If xCode.StartsWith("102") Then Return "One Family"
	If xCode.StartsWith("103") Then Return "Roots"
	If xCode.StartsWith("104") Then Return "Music Makers"
	If xCode.StartsWith("105") Then Return "Saxons"
	If xCode.StartsWith("106") Then Return "Prodigal Sons"
	If xCode.StartsWith("107") Then Return "Genesis"

	If xCode.StartsWith("201") Then Return "Colours Entertainment"
	If xCode.StartsWith("202") Then Return "Fancy Dancers"
	If xCode.StartsWith("203") Then Return "Redland Soldiers"
	If xCode.StartsWith("204") Then Return "Conquerors for Christ"
	If xCode.StartsWith("205") Then Return "Original Congos"
	If xCode.StartsWith("206") Then Return "'Body of Christ"
	If xCode.StartsWith("207") Then Return "Chipping Knights"
	If xCode.StartsWith("208") Then Return "The Ultimate Force"
	If xCode.StartsWith("209") Then Return "Mercenaries"
	If xCode.StartsWith("210") Then Return "Z-Bandits"
	If xCode.StartsWith("211") Then Return "The New Vikings"
	If xCode.StartsWith("212") Then Return "Foundations"

	If xCode.StartsWith("401") Then Return "Anthony Smith"
	If xCode.StartsWith("402") Then Return "Teran Davis"
	If xCode.StartsWith("403") Then Return "Andrew Stubbs"
	If xCode.StartsWith("404") Then Return "Tarj Davis"
	If xCode.StartsWith("405") Then Return "Renee Etienne"
	If xCode.StartsWith("406") Then Return "Bernard Davis"
	If xCode.StartsWith("407") Then Return "Mario Stubbs Sr."
	If xCode.StartsWith("408") Then Return "Anthony Etienne"
	If xCode.StartsWith("409") Then Return "Robert Martin Jr."
	If xCode.StartsWith("410") Then Return "L. John Barrett"
	If xCode.StartsWith("411") Then Return "Randy Deveaux"
	If xCode.StartsWith("412") Then Return "Otario Allen"
	If xCode.StartsWith("413") Then Return "Jack Saunders"
	If xCode.StartsWith("414") Then Return "D. Terre Thompson"
	If xCode.StartsWith("415") Then Return "Mario Stubbs Jr."
	If xCode.StartsWith("416") Then Return "Gerald Lotmore"

	Return "Error"
End Sub

Sub GetZone(xJudge As Int) As Int
	If xJudge <= 2 Then Return 1
	If xJudge <= 4 Then Return 2
	If xJudge <= 6 Then Return 3
	If xJudge <= 8 Then Return 1
	If xJudge <= 10 Then Return 2
	If xJudge <= 12 Then Return 3
	If xJudge <= 14 Then Return 1
	If xJudge <= 16 Then Return 2
	If xJudge <= 18 Then Return 3
	If xJudge <= 20 Then Return 1
	If xJudge <= 22 Then Return 2
	If xJudge <= 24 Then Return 3
	If xJudge <= 26 Then Return 1
	If xJudge <= 28 Then Return 2
	If xJudge <= 30 Then Return 3
	If xJudge <= 32 Then Return 1
	If xJudge <= 34 Then Return 2
	If xJudge <= 36 Then Return 3
	If xJudge <= 38 Then Return 1
	If xJudge <= 40 Then Return 2
	If xJudge <= 42 Then Return 3

	Return 0
End Sub

Sub GetInfraction(xCode As String) As String
	If xCode.StartsWith("P1") Then Return "Swapping of Numbers"
	If xCode.StartsWith("P2") Then Return "Contravening the designated order by Group"
	If xCode.StartsWith("P3") Then Return "Contravening with the designated order by Individual"
	If xCode.StartsWith("P4") Then Return "Failure To meet the time limit Division A - 80 mins / Division B 50 mins."
	If xCode.StartsWith("P5") Then Return "No group identification number on banner"
	If xCode.StartsWith("P6") Then Return "More than four wheels on lead costume"
	If xCode.StartsWith("P7") Then Return "Motorized vehicle"
	If xCode.StartsWith("P8") Then Return "Obstruction of parade route"
	If xCode.StartsWith("P9") Then Return "Lighting fires on parade route"
	If xCode.StartsWith("PA") Then Return "Use of firework by individual members"
	If xCode.StartsWith("PB") Then Return "Use of fireworks by Group"
	If xCode.StartsWith("PC") Then Return "Live animals prohibited"
	If xCode.StartsWith("PD") Then Return "Obstruction of parade by individual costume"
	If xCode.StartsWith("PE") Then Return "Any visible cloth undergarment"

	Return "Error"
End Sub

Sub MakeTime(xTime As String) As String
	Private xHour As Int


	xHour=xTime.SubString2(0,2)

	If xHour < 12 Then
		Return xTime.SubString2(0,2) & ":" & xTime.SubString2(2,4) & " AM"
	Else
		xHour = xHour - 12
		Return xHour & ":" & xTime.SubString2(2,4) & " PM"
	End If
End Sub